!========================================================
!The acceleration functions f3,f4(t,x1,x2,v1,v2) provided
!by the user
!========================================================
!Motion in hydrogen atom + positron:
!f(r) = 1/r^2-r/k1^3
!ax= f(r)*x1/r ay= f(r)*x2/r
real(8) function f3(t,x1,x2,v1,v2)
 implicit none
 real(8) :: t,x1,x2,v1,v2
 real(8) ::         k1,k2
 common  /couplings/k1,k2
 real(8) :: r2,r,fr
 r2=x1*x1+x2*x2
 r =sqrt(r2)
 if(r .le.k1    .and. r2.gt.0.0D0)then
  fr = 1/r2-r/k1**3
 else
  fr = 0.0D0
 endif

 if(fr.gt.0.0D0 .and. r .gt.0.0D0)then
  f3=fr*x1/r              !dx3/dt=dv1/dt=a1
 else
  f3=0.0D0
 endif
end function f3
!--------------------------------------------------------
real(8) function f4(t,x1,x2,v1,v2)
 implicit none
 real(8) :: t,x1,x2,v1,v2
 real(8) ::         k1,k2
 common  /couplings/k1,k2 
 real(8) :: r2,r,fr
 r2=x1*x1+x2*x2
 r =sqrt(r2)
 if(r .le.k1    .and. r2.gt.0.0D0)then
  fr = 1/r2-r/k1**3
 else
  fr = 0.0D0
 endif

 if(fr.gt.0.0D0 .and. r .gt.0.0D0)then
  f4=fr*x2/r              !dx3/dt=dv1/dt=a1
 else
  f4=0.0D0
 endif
end function f4
!--------------------------------------------------------
real(8) function energy(t,x1,x2,v1,v2)
 implicit none
 real(8) :: t,x1,x2,v1,v2
 real(8) ::         k1,k2
 common  /couplings/k1,k2
 real(8) :: r,Vr
 r=sqrt(x1*x1+x2*x2)
 if( r .le.k1   .and. r .gt.0.0D0)then
  Vr = 1/r + 0.5D0*r*r/k1**3 - 1.5D0 / k1
 else
  Vr = 0.0D0
 endif
 energy  = 0.5D0*(v1*v1+v2*v2) + Vr
end function energy
